

CLR EQU 256 ; clear alphabet
EOF EQU 257 ; End of GIF file

w dw ?
b db ?

handle   dw ?
buf      db 768 dup(0)
bufind   dw ?
abstack  db 1281 dup(0)
ab_prfx  dw 4096 dup(0)
ab_tail  dw 4096 dup(0)
free     dw 0
width1   dw 0
max      dw 0
stackp   dw 0
restbits dw 0
restbyte dw 0
specialcase dw 0
cur_code dw 0
old_code dw 0
readbyt  dw 0
lbyte    dw 0

; ===========================================================================
gifread proc far
; CX = number of bytes to read
; ===========================================================================
        mov  ax, 3f00h
        mov  bx, handle
;        mov  cx, n
        lea  dx, buf
        int  21h
        ret
gifread endp

; ===========================================================================
gifopen proc far
; DX = gifname+1  len+ascii
; ===========================================================================
        mov  ax, 3d00h
;        lea  dx, gifname + 1
        int  21h
        mov  handle, ax
        ret
gifopen endp

; ===========================================================================
gifclose proc far
; ===========================================================================
        mov  ax, 3e00h
        mov  bx, handle
        int  21h
        ret
gifclose endp

gifofs dd ?

; ===========================================================================
gifseek proc far
; ===========================================================================
        mov  ax, 4200h
        mov  bx, handle
        mov  cx, word ptr cs:gifofs + 2
        mov  dx, word ptr cs:gifofs
        int  21h
        ret
gifseek endp

; ===========================================================================
shiftpal proc far
; convert from 24bit to 18bit VGA
; ===========================================================================
        mov  ax, ds
        mov  es, ax
        mov  si, offset buf
        lea  di, palette
        mov  cx, 768
@11:
        lodsb
        shr al, 2
        stosb
        loop @11
        ret
shiftpal endp

; ===========================================================================
fillbuf proc far
; ===========================================================================
        mov  cx, 1
        call gifread
        mov  al, byte ptr buf[0]
        xor  ah, ah
        mov  restbyte, ax
        mov  cx, ax
        call gifread
        ret
fillbuf endp


