; ===========================================================================
; === TOOLBOX DATA                                                        ===
; ===========================================================================
TOOL_DATA:
         PI EQU 3.1415927

         i               db 1
         J               db 0
         K               db 0
         L               db 0
         W               dw 0
        
         NUM            dw ?
         RANGE          dw ?
         SB             dw ?
         CHAR           db ?
         BASE           dw ?
        seed            dw 0
        lower           dw 0
        upper           dw 0
        MULTIPLIER      dw 25173

        fc_handle       dw ?
        fc_handle2      dw ?
        fcdate1         dw 0      ;file date
        fcdate2         dw 0      ;file date
        old_drive       db 0
                        db ':'
        old_sep         db '\'
        old_path        db 40 dup (0)
        new_path        db 40 dup (0)
        _OS             dw 0
        _OS_VER         dw 0
        _OS_REV         db 0
        _OS_ROM         db 0

        _COLOR1         db ?
        _COLOR          db ?
        _LASTBANK1      db ?
        _LASTBANK       db ?
        _VX1            dw ?
        _VX             dw ?
        _VY1            dw ?
        _VY             dw ?
        _BYTESPERROW1   dw ?
        _BYTESPERROW    dw ?
        _colormode      db 3
        _monomode       db 7
        _OldMode        db ?          ; Initialized to some standard mode
        _vidmode        db ?
        _screenrows     db 0
        TextAttr        db 7
        NormAttr        db 7fh
        directvideo     db 0

VendorSign      db 13 dup(0)
Chipset         db 0
vid_features    db 0              ; Those RCA connectors
vid_switches    db 0              ; Videoboard jumpers
vid_memsize     db 0              ; >4 CGA or MDA 
vid_default     db 0              ; 0=color, 1=mono
VESAVIDEO       db 0              ; boolean
; The VESASignature field contains the characters 'VESA'
; if this is a valid block.
VESASignature   db 4 dup(' ')     ; 4 signature bytes
VESAVersion     dw ?              ; VESA version number
VESAOEMptr      dd ?              ; Pointer to OEM string
VESACapability  db 4 dup(?)       ; capabilities of the video environment
VideoModePtr    dd ?              ; pointer to supported Super VGA modes
Videomemory     dw ?              ; Number of 64kb memory blocks on board
VESAReserved    db 236 dup(?)     ; Remainder of VgaInfoBlock
videoinf_size EQU $ - Chipset
        _len$      EQU 255
        _extralen$ dw 127
        _bufpos    db 0
        _buffer    db _len$ dup(0)

        _AX             db 'AX=',00h
        _BX             db 'BX=',00h
        _CX             db 'CX=',00h
        _DX             db 'DX=',00h
        _CS             db 'CS=',00h
        _IP             db 'IP=',00h
        _DS             db 'DS=',00h
        _ES             db 'ES=',00h
        _SI             db 'SI=',00h
        _DI             db 'DI=',00h
        _SP             db 'SP=',00h
        _BP             db 'BP=',00h
        _SS             db 'SS=',00h
        _FL             db 'FL=',00h
        _X              db ' X=',00h
        _Y              db ' Y=',00h
     dbgtrace           db 'Debug trace, we are being watched!',0ffh,0
     ;                  db '0EAh CS:0FA1l=',0fdh,45,'0EF1',0ffh,00h
     ; dbgmess          db 'We are free!',0ffh,00h  
        _pp_data        db 'Press any key when ready...',00h
                           ; [SlaM dA EnTeR kEy FoO]
        _overflow_msg   db 0ffh,'OVERFLOW> ',00h
        _badinput       db 0ffh,'ILLEGAL> ',0
        err01 db 'Invalid function number'
        err02 db 'File not found         '
        err03 db 'Path not found         '
        err04 db 'Too many open files    '
        err05 db 'File access denied     '
        err06 db 'Invalid file handle    '
        err07 db 'MCBS Destroyed         '
        err08 db 'Out of memory          '
        err09 db 'Invalid memory block   '
        err0A db 'Invalid environment    '
        err0B db 'Invalid format         '
        err0C db 'Invalid file access #  '
        err0D db 'Invalid data           '
        err0E db 'Invalid cause          '
        err0F db 'Invalid drive number   '
        err10 db 'Unable to remove path  '
        err11 db 'Device not the same    '
        err12 db 'No more files          '
        err13 db 'Disk write protected   '
        err14 db 'Unknown unit           '
        err15 db 'Disk not ready         '
        err16 db 'Unknown command        '
        err17 db 'Data (CRC) error       '
        err18 db 'Invalid structure      '
        err19 db 'Seek error             '
        err1A db 'Unknown medium type    '
        err1B db 'Sector not found       '
        err1C db 'Printer out of paper   '
        err1D db 'Disk write error       '
        err1E db 'Disk read error        '
        err1F db 'General failure        '
        errorlen  EQU $ - err1f
;      errors DW      err01, err02, err03, err04, err05, err06, err07
;             DW      err08, err09, err0A, err0B, err0C, err0D, err0E, err0F
;             DW      err10, err11, err12, err13, err14, err15, err16, err17
;             DW      err18, err19, err1A, err1B, err1C, err1D, err1E, err1F
romann db 'IVXLCDM'
romanv dw 1,5,10,50,100,500,1000

n0_NXDOS   db 'NeXt-DOS (NX-DOS)',0
n1_MSDOS   db 'MS-DOS   (PC-DOS)',0
n2_DDDOS   db 'DoubleDos        ',0
n3_NETW    db 'Novell Netware   ',0
n4_DESQV   db 'DesqView         ',0
n5_MSWIN   db 'MicroSoft Windows',0
n6_IBMOS2  db 'IBM OS/2         ',0
osnamesize EQU $ - n6_IBMOS2

Chipset_msg  db 'Chipset ',0
NONVGA       db 'BIOS        ',0
PCIVIDEO     db 'PCIVGA      ',0
PVGA1A       db 'PVGA1A      ',0
WD90C00      db 'WD90C00     ',0
WD90C10      db 'WD90C10     ',0
WD90C11      db 'WD90C11     ',0
V7VGA1024I   db 'V7VGA 1024i ',0 ; 7
V7VGAV5      db 'V7VGA Vers 5',0
V7VGAFWVRAM  db 'V7VGA FWVRAM',0
V7VEGAVGA    db 'V7 VEGA VGA ',0
TSENGET3000  db 'Tseng ET3000',0
TSENGET4000  db 'Tseng ET4000',0
TRIDENT8800  db 'Trident 8800',0
TRIDENT8900  db 'Trident 8900',0
VGADUMMY     db 'WOT VGA?    ',0
CHIPSETSIZE  EQU $ - VGADUMMY
VIDEOACCEL   db 'AGP/3DO',0

; fortran 77-REV1
;
; program name
; real, r area
;
; write(*,*) 'Give radius of r: ' 
; read(*,*) r
;
; area = 3.14159*r*r
; write(*,*) 'Area = ',area
;
; stop
; end
