; (*** Control characters for communications & other devices ***************)
        _NUL EQU 00       
        _SOH EQU 01       
        _STX EQU 02       
        _ETX EQU 03       
        _EOT EQU 04
        _ENQ EQU 05       
        _ACK EQU 06       
        BEL EQU 07
        _BS  EQU 08 
        _TAB EQU 09
        LF  EQU 10
        _VT  EQU 11
        _FF  EQU 12    
        CR  EQU 13   
        _SO  EQU 14
        __SI  EQU 15 
        _DLE EQU 16   
        _DC1 EQU 17 ;{^q} 
        _DC2 EQU 18 
        _DC3 EQU 19 ;{^s}
        _DC4 EQU 20  
        _SYN EQU 22    
        _NAK EQU 21  
        _ETB EQU 23
        _CAN EQU 24
        _EM  EQU 25     
        __SUB EQU 26 ;{1a} 
        _ESC EQU 27 
        _FS  EQU 28 
        _GS  EQU 29
        _RS  EQU 30      
        _US  EQU 31 ;{1f}   
        __SP  EQU 32   
        _UNIX_EOF EQU 255

; {*** Also used by printers for controlling between ONLINE & OFFLINE state }
        XON EQU  _DC1 ; {resume}    
        XOFF EQU _DC3 ; {pause}   
        LTAB EQU _SI  ; {<-htab}

; {*** Printer Codes : ESC starts a command, NUL ends a command ************ }
        CPI10 EQU _DC2
        CPI17 EQU __SI ; { condensed mode 17cpi... cancelled by DC2}
        PRN_DOUBLEWIDE EQU _SO ; {cancelled by DC4}  
        PRN_DeSelect   EQU _DC3
        ; { **** not supported in the bjc-600 **** }
        PRN_Reverse_ff EQU 93 ; { esc ] }          
        PRN_direction  EQU 85 ; { esc U }
; (*** end character constants *********************************************)

