; FREEBSD defines for NXDOS kernel 6/16/2006

stdin  EQU 0
stdout EQU 1
stderr EQU 2

SYS_NOSYS EQU 0
SYS_EXIT  EQU 1
SYS_FORK  EQU 2
SYS_READ  EQU 3
SYS_WRITE EQU 4

; access the nsd kernel
BSD_KERNEL EQU 80h         ; int 80h

bsd_system  macro bsd_function
	    mov  ax, bsd_function
	    int  BSD_KERNEL
	    ; ret
            endm

; ===========================================================================
bsd_exit proc far
; ===========================================================================
	bsd_system SYS_EXIT
	ret
bsd_exit endp

; ===========================================================================
bsd_fork proc far
; ===========================================================================
	bsd_system SYS_FORK
	ret
bsd_fork endp

; ===========================================================================
bsd_read proc far
; ===========================================================================
	bsd_system SYS_READ
	ret
bsd_read endp

; ===========================================================================
bsd_write proc far
; ===========================================================================
	bsd_system SYS_WRITE
	ret
bsd_write endp
