; NXDOS KERNEL Copyright 2004-2006 Christopher Evans
; email:   tekno1911@yahoo.com
; Website: http://nxdos.sourceforge.net/
;
; NX DOS boot sector is loaded from head 0, cylinder0, sector 1 into 0:7c00
; The Kernel is loaded from firstdata sector on media into 0060:0000 segment.
; File Allocation Table is sectors 2 to 18h... i think
;
; To assemble NX-DOS binaries type: make boot nxbio command sys
;                                                                           ;
;       This program is copyrighted, but may be freely distributed          ;
;       under the terms of the Free Software Foundation's GNU General       ;
;       Public License v2 (or later.)  See the file COPYING for the         ;
;       legalities.  If you did not receive a copy of COPYING, you          ;
;       may request one from the Free Software Foundation, Inc.,            ;
;       59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           ;
;       ABSOLUTELY NO WARRANTY -- use it at your own risk!                  ;
;                                                                           ;


              ;  P386N
              ;.486
              ;.487
              .286c
              .287

code            segment byte public
                assume  cs:code, ds:code, ss:code

                org     0h

core     proc    near                            ; loaded at 0060:0100
start:
         push cs
         pop  ax
         mov  ds, ax
         mov  es, ax
         mov  ax, 0050h
         mov  ss, ax    ; 0050:FFFF
         mov  bp, 0ffffh
         mov  sp, bp
         mov  NXDOSSEG, ax
         ;
         call cs:init
         ;
         mov  al, errorlevel
_exit:   call cs:exit
         ret
core     endp

include  \nxdos\src\kernel\kernel.asm
         _compile
code     ends

ProgramEnd      EQU $-01h

         end     start
