; ===========================================================================
; Toolbox.asm contains video routines
; ===========================================================================
Gfxpnext      dd 0ffff0000h
Gfxdevattr    dw 1000000000000100b 
Gfxstrategy   dw offset _gfx_strategy
Gfxinterrupt  dw offset _gfx_interrupt
Gfx_device    db 'GFX     ' ; Blank-padded device (or 10-byte block device sub-unit number)
; Jump table 
gfxtable      db 9
              dw cs:gfx_init    ; 0 - initialize driver
              dw cs:gfx_err     ; 1 - media change check 
              dw cs:gfx_err     ; 2 - build BPB
              dw cs:gfx_err     ; 3 - IOCTL string output
              dw cs:gfx_input   ; 4 - input
              dw cs:gfx_input   ; 5 - nondestructive input
              dw cs:gfx_err     ; 6 - input status
              dw cs:gfx_clear   ; 7 - input flush
              dw cs:gfx_output  ; 8 - output
              dw cs:gfx_showinfo; 9 - output w/ verify

GFX:

include \nxdos\src\kernel\gfx.asm

; ===========================================================================
gfx_init proc far
; ===========================================================================
       ; Call detection routine in TOOLBOX.ASM
       mov  ah, 1
       call cs:videomode                 ; call cs:detectvideohardware
       ;
       call cs:gmain

;       _output Gfx_device, 8, 1

       ret
_gfx_strategy:

       retf 
_gfx_interrupt:

       retf 
gfx_init endp

; ===========================================================================
gfx_err  proc far
; ===========================================================================

       ret
gfx_err  endp

; ===========================================================================
gfx_input proc far
; ===========================================================================

       ret
gfx_input endp

; ===========================================================================
gfx_output proc far
; ===========================================================================

       ret
gfx_output endp

; ===========================================================================
gfx_clear  proc far
; ===========================================================================

       ret
gfx_clear  endp

; ===========================================================================
gfx_showinfo proc far
; ===========================================================================
       call cs:show_videohardware
       ret
gfx_showinfo endp

; ===========================================================================
gmain proc far
; ===========================================================================
      mov  ax, 13h
      call cs:openvideo
;      call setvideo
      jc   gtesterr

      mov  bl, 08h
      call fillscrn
      ;

      _drawline 1, 1, 5

  ;    mov  ax, 2
  ;    call setvideo
      call cs:closevideo
      jmp  short gtestx
gtesterr:
      _print cs:novgamsg, 1
gtestx:
      ret
gmain endp
