
; Copyright 2004-2005 Christopher Evans
; Website: http://nxdos.sourceforge.net/
;                                                                           ;
;       This program is copyrighted, but may be freely distributed          ;
;       under the terms of the Free Software Foundation's GNU General       ;
;       Public License v2 (or later.)  See the file COPYING for the         ;
;       legalities.  If you did not receive a copy of COPYING, you          ;
;       may request one from the Free Software Foundation, Inc.,            ;
;       59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           ;
;       ABSOLUTELY NO WARRANTY -- use it at your own risk!                  ;
;                                                                           ;

code            segment byte public
                assume  cs:code, ds:code
		org	100h
testapp         proc    far

start:          jmp     initialize
include         toolbox.asm
                include kernel\testing.asm
                v1 dw 1
                v2 dw 1
                woop db '-HERE>'
                datad dd 1
                msg db 'test message.',24h,0ffh,0
initialize:

;                push cs
;                pop  es
;                mov  bx, ProgramEnd
;                call resize
;                jc   exitptr
                     call cs:main
exitptr:
                call debugregisters
                call dosexit
                int 20h      

testapp         endp

main proc far
; 1.100
; 0.999
;+=====
; 2.099
      _cprintf 1, 1 
      _newline
      _cprintf 0, 999 
      _newline
      _Float_Add 1, 1, 0, 999
      call putnum
      _echo '.'  
      mov  ax, dx
      call putnum 
      _newline
     ret
main endp

code            ends

ProgramEnd      EQU $-01h

		end	start
test2 proc far
                push  cs
                pop   ds
                mov   cx, aa_size
                lea   si, aa_data
                xor   dx, dx
                xor   bx, bx
checker_loop:   mov   al, byte ptr ds:[si]
                cmp   al, 0aah
                je    byteok
                inc   dx
byteok:
                inc   bx
                loop  checker_loop


                mov  ax, dx
                or   ax, ax
                jz   nomismatch
                mov  ah, 0eh
                mov  al, 'M'
                int  10h
nomismatch:
                mov   cx, aa_size
                mov   ax, bx
                cmp   ax, cx
                je      correctsize
                mov  ah, 0eh
                mov  al, '2'
                int  10h
correctsize:
      ret
aa_size         equ 1024
aa_data         db  aa_size dup(0aah)
test2 endp

     call pci_enum

     push cs
     pop  es
     lea  si, chipset
     mov  cx, videoinf_size
     call debugdump
     _newline
     call showchipset
     _newline
     call checkcpu
     call putnum
     _newline
     _print vendorsign, 1
     _newline
