code            segment byte public
                assume  cs:code, ds:code
		org	100h
ask             proc    far

start:          jmp     initialize
header db 'ASK Utility',0,'$'
include         \nxdos\src\toolbox.asm
                _compile
initialize:
        call cs:show_cmdline
        mov  ah, 8
        int  21h
        cmp  al, 'y'
        je   yesresp
        cmp  al, 'Y'
        je   yesresp
noresp:
        _display no_msg, 1
        mov  ax, 0
        jmp  askdone

yesresp:
        _display yes_msg, 1
        mov  ax, 1
askdone:

exitptr:
        call dosexit
        int 20h      

ask     endp

show_cmdline proc far
psp_cmd_size	equ	80h
psp_cmd_tail    equ     82h
     mov bl, cs:psp_cmd_size
     xor bh, bh                 
     add bx, 81h
     mov byte ptr [bx], 24h     
     mov dx, psp_cmd_tail
     mov ah, 9
     int 21h                    
     ret                        
show_cmdline endp

yes_msg db ' yes',0ah,0dh,24h
no_msg  db ' no',0ah,0dh,24h

code            ends

ProgramEnd      EQU $-01h

		end	start
